/*
	LGS core include file!

	(c) Menne Kamminga AKA AnalyticaL

	-This is the new core definitions file required in most scripts for lscript.
	-Automaticly includes other parts of the LGS core library
*/

/*
	Default system variables:
*/

float		internal $Size;// The size of an object
float		internal $Texture;// The current texture
float		internal $Rotation;// The rotation of the Z axis of an object
int 		internal $Facing;// The facing of an object -1 left 1 right
float		internal $Offset_x;// position on the x axis of an object
float		internal $Offset_y;// position on the y axis of an object
float		internal $Offset_z;// position on the z axis of an object
float		internal $Random;// Contains a random number
int 		internal $ModelFlags;// Magick model flag.... set bits of this flag to enable/disable parts of a model.
int 		internal $World_Timestop;// Set to 1 when time is stopped!
float		internal $TEXblood1;// Contains texture
float		internal $TEXblood2;// Contains texture
float		internal $TEXblood3;// Contains texture
float		internal $TEXshatter1;// Contains texture

/*
	Other vars:
*/


//Default library include shortcuts: (These find out for themselves if they are needed or not! :) )
@defimport	"fx.aura"					"data/corescripts/def_aura.inc"					<stdDrawAura> 
@defimport	"fx.bbeam"					"data/corescripts/def_bbeam.inc"				<stdDrawbbeam> 
@defimport	"fx.beam"					"data/corescripts/def_beam.inc"					<stdDrawBeam>
@defimport	"fx.disc"					"data/corescripts/def_disc.inc"					<stdDrawDisc>
@defimport	"fx.disableaura"			"data/corescripts/def_disableaura.inc"			<stdDisableAura> 
@defimport	"fx.lightrays"				"data/corescripts/def_lightbeams.inc"			<drawlightBeams>
@defimport	"fx.shockwave"				"data/corescripts/def_shockwave.inc"			<DrawShockWave>
@defimport	"fx.wave"					"data/corescripts/def_wave.inc"					<DrawWave>
@defimport	"fx.rotate"					"data/corescripts/def_rotate.inc"				<rotatestuff>
@defimport	"fx.kiinhand"				"data/corescripts/def_smallkiball.inc"			<stdDrawSmallKiballInHand>

/*the color-included and texture-set-by-default-to-0 functions leak in flexibility &
	user-friendlyness; started a new set to replace the old step by step in future */

@defimport	"fx.ballinhand"				"data/corescripts/def_smallball.inc"			<stdDrawSmallBallInHand>
@defimport	"fx.kibeam"					"data/corescripts/def_kibeam.inc"				<stdDrawKiBeam> 
@defimport	"fx.kiflash"				"data/corescripts/def_flash.inc"				<stdDrawKiFlash> 
@defimport	"fx.newshockwave"			"data/corescripts/def_newshockwave.inc"			<DrawNewShockWave>
@defimport	"fx.explodingsprite"		"data/corescripts/def_explodingsprite.inc"		<stdExplodingSprite>
@defimport	"core.playerrender"			"data/corescripts/def_player.inc"				<RenderDefaultPlayer>


@defimport	"fx.boost"			"data/corescripts/def_boost.inc"				<stdBoost>
//new scripts for stronger balancecontrol about cost, charging, size
@defimport	"fx.charge"			"data/corescripts/def_charge.inc"				<stdCharge>
@defimport	"fx.size"			"data/corescripts/def_size.inc"				<stdSize>
@defimport	"fx.bonus"			"data/corescripts/def_bonus.inc"				<stdBonus>
@defimport	"fx.speedup"			"data/corescripts/def_speedup.inc"				<stdSpeedup>
@defimport	"fx.auraoff"			"data/corescripts/def_auraoff.inc"				<stdAuraoff>
@defimport	"fx.position"			"data/corescripts/def_position.inc"				<stdPosition>

//Smartly import nescesary stuff:
@import "fx.aura"
@import "fx.bbeam"
@import "fx.beam"
@import "fx.disc"
@import "fx.disableaura"
@import "fx.lightrays"
@import "fx.shockwave"
@import "fx.wave"
@import "fx.rotate"
@import "fx.kiinhand"
@import "fx.ballinhand"
@import	"fx.kibeam"						
@import	"fx.kiflash"
@import	"fx.newshockwave"
@import "fx.explodingsprite"
@import "core.playerrender"
@import	"fx.boost"
@import	"fx.charge"
@import	"fx.size"
@import	"fx.bonus"
@import	"fx.speedup"
@import	"fx.auraoff"
@import	"fx.position"