/*
LGS CORE: draw a beam 
(c) 2008 Menne Kamminga AKA AnalyticaL; Edited by Loozzer

This draws a beam with adjustabble color, transparency and width
-Needs 1 texture, set it with 0,1,2...
-stdDrawBeamAura(R,G,B,A,Size,Texture)
R = red
G = green
B = Blue
A = transparency
Size = width of the beam (e.g.Kamehameha	
Texture = select the texture set

<Example>

#texture data/graphics/balks/sbc.tga

function main(){
stdDrawBeamAura(1.0,1.0,1.0,Trnasparency,$Size,0);
}

</Example>


*/

function stdDrawbbeam (float $Color_R,float $Color_G,float $Color_B,float $Color_A,float $Size,resource $texture) {
	float $stdX1;
	float $stdX2;
	float $stdY1;
	float $stdY2;
	float $stdLEN;
	float $stdTexOffset;
	float $stdTspeed;
	float $stdTX1;
	float $stdTY1;
	float $stdTY2;
	float $stdTX2;
	float $stdThickness;
	float $stdBeamstartX;
	float $stdBeamL;

	Length3d($stdBeamL,$Move_startx,$Move_starty,0.0);

	texture_set($texture);
	glColor4f($Color_R,$Color_G,$Color_B,$Color_A);

	//calculate beam thickness
	$stdTspeed=1.0/$TimestampNormal;
	$stdTexOffset=$stdTexOffset+$stdTspeed;
	if($stdTexOffset>1.0) {
		$stdTexOffset=$stdTexOffset-1.0;
	}
	$stdThickness=$Size;
	//Check for left or right facing :) -1 is right: 1 is left :P
	if($Move_facing==-1) {
		$stdLEN=$Offset_x-$Move_startx-0.1;
		$stdY1=0.0+$stdThickness;
		$stdY2=0.0-$stdThickness;
		$stdTX1=0.0+$stdTexOffset;
		$stdTX2=$stdLEN+$stdTexOffset;
		$stdTY1=0.0;
		$stdTY2=1.0;
	}
	if($Move_facing==1){
		$stdLEN=$Offset_x-$Move_startx-0.1;
		$stdY1=0.0 + $stdThickness;
		$stdY2=0.0 - $stdThickness;
		$stdTX1=$stdLEN+$stdTexOffset;
		$stdTX2=0.0+$stdTexOffset;
		$stdTY1=0.0;
		$stdTY2=1.0;
	}

	glLoadIdentity();
	glTranslatef($Move_startx,$Move_starty,0.0);
	glRotatef($Rotation,0,0,1);
	if($Move_facing==1) {
		glRotatef(180.0,0,1,0);
	}


	//Draw the beam:
	glBegin(GL_QUADS);
	glTexCoord2f($stdTX1,$stdTY1);	glVertex2f(0.05,$stdY1);
	glTexCoord2f($stdTX2,$stdTY1);	glVertex2f($stdBeamL,$stdY1);
	glTexCoord2f($stdTX2,$stdTY2);	glVertex2f($stdBeamL,$stdY2);
	glTexCoord2f($stdTX1,$stdTY2);	glVertex2f(0.05,$stdY2);
	glEnd();
}



