/*
LGS CORE: draw standard beam

(c) 2008 Menne Kamminga AKA AnalyticaL

This draws a default beam
-Needs 2 textures!
-endtype 0 == flash on end, endtype 1 == ball on end

<Example>

#texture data/characters/krillin/textures/diahameha_texture_balk.tga
#texture data/characters/krillin/textures/diahameha_texture_flame.tga

function main(){
stdDrawBeam(1.0,1.0,1.0,$Size,1.7,0,0);
}

</Example>


*/

function stdDrawBeam (float $Color_R,float $Color_G,float $Color_B,float $Size,float $HeadSize,int $StartType,int $EndType,resource $texture_beam, resource $texture_flame) {
	float $stdX1;
	float $stdX2;
	float $stdY1;
	float $stdY2;
	float $stdLEN;
	float $stdTexOffset;
	float $stdTspeed;
	float $stdTX1;
	float $stdTY1;
	float $stdTY2;
	float $stdTX2;
	float $stdThickness;
	float $stdBeamstartX;
	float $stdBeamL;

	Length3d($stdBeamL,$Move_startx,$Move_starty,0.0);

	texture_set($texture_beam);
	glColor4f($Color_R,$Color_G,$Color_B,1.0);

	//calculate beam thickness
	$stdTspeed=1.0/$TimestampNormal;
	$stdTexOffset=$stdTexOffset+$stdTspeed;
	if($stdTexOffset>1.0) {
		$stdTexOffset=$stdTexOffset-1.0;
	}
	$stdThickness=$Size/8.0;
	//Check for left or right facing :) -1 is right: 1 is left :P
	if($Move_facing==-1) {
		$stdLEN=$Offset_x-$Move_startx-0.1;
		$stdY1=0.0+$stdThickness;
		$stdY2=0.0-$stdThickness;
		$stdTX1=0.0+$stdTexOffset;
		$stdTX2=$stdLEN+$stdTexOffset;
		$stdTY1=0.0;
		$stdTY2=1.0;
	}
	if($Move_facing==1){
		$stdLEN=$Offset_x-$Move_startx-0.1;
		$stdY1=0.0 + $stdThickness;
		$stdY2=0.0 - $stdThickness;
		$stdTX1=$stdLEN+$stdTexOffset;
		$stdTX2=0.0+$stdTexOffset;
		$stdTY1=0.0;
		$stdTY2=1.0;
	}

	glLoadIdentity();
	glTranslatef($Move_startx,$Move_starty,0.0);
	glRotatef($Rotation,0,0,1);
	if($Move_facing==1) {
		glRotatef(180.0,0,1,0);
	}


	//Draw the beam:
	glBegin(GL_QUADS);
	glTexCoord2f($stdTX1,$stdTY1);
	glVertex2f(0.05,$stdY1);
	glTexCoord2f($stdTX2,$stdTY1);
	glVertex2f($stdBeamL,$stdY1);
	glTexCoord2f($stdTX2,$stdTY2);
	glVertex2f($stdBeamL,$stdY2);
	glTexCoord2f($stdTX1,$stdTY2);
	glVertex2f(0.05,$stdY2);
	glEnd();

	//Draw the beam start:
	texture_set($texture_flame);
	Static_DrawFlash(-0.01,0.0,$Size,-90.0);


	//Draw the Beam End
	if($EndType==0) {
		//Flash on the end:
		$stdBeamL+=$Size;
		$Size*=$HeadSize;
		glLoadIdentity();
		glTranslatef($Move_startx,$Move_starty,0.0);
		glRotatef($Rotation,0,0,1);
		if($Move_facing==1) {
			glRotatef(180.0,0,1,0);
		}
		Static_DrawFlash($stdBeamL,0.0,$Size,90.0);
	}

	if($EndType==1) {
		//Ball on the end:
		glDisable(GL_TEXTURE_2D);
		Sphere($Size);
		glEnable(GL_TEXTURE_2D);
	}
}
