/*
   LGS CORE: draw standard beam

   type 0: textured, streching, rotating& repeating rectangles
   type 1: streched texture

   <Example>

#texture data/characters/krillin/textures/diahameha_texture_balk.tga
#texture data/characters/krillin/textures/diahameha_texture_flame.tga

function main(){
stdDrawBeam(1.0,1.0,1.0,$Size,1.7,0,0);
}

</Example>


 */

function stdDrawKiBeam (resource $Texture,float $Thickness,int $type) {
	float $stdX1;
	float $stdX2;
	float $stdY1;
	float $stdY2;
	float $stdLEN;
	float $stdTexOffset;
	float $stdTspeed;
	float $stdTX1;
	float $stdTY1;
	float $stdTY2;
	float $stdTX2;
	float $stdThickness;
	float $stdBeamstartX;
	float $stdBeamL;
	float $TEMP;
	float $TEMP1;	
	float $BeamL;

	if($type==0) {
		Length3d($stdBeamL,$Move_startx,$Move_starty,0.0);
		texture_set($Texture);
		//calculate beam thickness
		$stdTspeed=1.0/$TimestampNormal;
		$stdTexOffset=$stdTexOffset+$stdTspeed;
		if($stdTexOffset>1.0) {
			$stdTexOffset=$stdTexOffset-1.0;
		}
		$stdThickness=$Thickness;

			$stdLEN=$Offset_x-$Move_startx-0.1;
			$stdY1=0.0+$stdThickness;
			$stdY2=0.0-$stdThickness;
			$stdTX1=0.0+$stdTexOffset;
			$stdTX2=$stdLEN+$stdTexOffset;
			$stdTY1=0.0;
			$stdTY2=1.0;


		glLoadIdentity();
		glTranslatef($Move_startx,$Move_starty,0.0);
		
		glRotatef($Rotation,0,0,1);
		if($Move_facing==1) {
			glRotatef(180.0,0,1,0);
		}
		//Draw the beam:
		glBegin(GL_QUADS);
		glTexCoord2f($stdTX1,$stdTY1);	glVertex2f(0.05,$stdY1);
		glTexCoord2f($stdTX2,$stdTY1);	glVertex2f($stdBeamL,$stdY1);
		glTexCoord2f($stdTX2,$stdTY2);	glVertex2f($stdBeamL,$stdY2);
		glTexCoord2f($stdTX1,$stdTY2);	glVertex2f(0.05,$stdY2);
		glEnd();
	}
	if($type==1) { 	
		Length3d($BeamL,$move_startx,$Move_starty,0.0);
		glLoadIdentity();
		glTranslatef($Move_startx,$Move_starty,0.0);
		glRotatef($Rotation,0,0,1);
		if($Move_facing==1) {
			glRotatef(180.0,0,1,0);
		}
		texture_set($Texture);
		$TEMP=0-$Thickness*2.0;
		$TEMP1=$Thickness*2.0;
		glBegin(GL_QUADS);
		glTexCoord2f(1.0,1.0);	glVertex3f($BeamL,$TEMP1,0.0);
		glTexCoord2f(1.0,0.0);	glVertex3f($BeamL,$TEMP,0.0);
		glTexCoord2f(0.0,0.0);	glVertex3f(0,$TEMP,0.0);
		glTexCoord2f(0.0,1.0);	glVertex3f(0,$TEMP1,0.0);
		glEnd();
	}
}
