/*
	LGS CORE: draw light beams 

	(c) 2008 Menne Kamminga AKA AnalyticaL

	core function to render light beams: 
	
	example:

	//Set the transparancy
	$defColorA=($TEMP-0.5)*2.0;
	//Set the color:
	$defColorR=1.0;
	$defColorG=1.0;
	$defColorB=1.0;
	//Jump to the included function
	drawlightBeams();

*/

float $defRsize2;
float $defRsize;
float $defRoff;
float $defColorR;
float $defColorG;
float $defColorB;
float $defRandoms[20];
float $defColorA;


function DoInit () {
	//Fill array with random 0-360 numbers.
	int $defIdx;
	foreach($defRandoms index $defIdx) {
		$defRandoms[$defIdx] = $Random;
		$defRandoms[$defIdx]*=360.0;
	}
}


//Function for drawing a single 3d arm:
function DrawSingleArm () {
	glBegin(GL_TRIANGLES);
	glColor4f($defColorR,$defColorG,$defColorB,$defColorA);
	glVertex3f(0.0,$defRoff,0.0);
	glColor4f($defColorR,$defColorG,$defColorB,0.0);
	glVertex3f($defRsize2,$defRsize,0.0);
	invf($defRsize2);
	glVertex3f($defRsize2,$defRsize,0.0);
	glEnd();
}


function drawlightBeams () {
	int $defRanInit;
	if($defRanInit==0){
		DoInit();
		$defRanInit=1;
	}

	if($defColorA<-0.99) {
		$defRanInit=0;
	}

	$defRsize=$Size*1.9;
	$defRoff=$Size/3.0;
	$defRsize2=$defRsize/6.5;

	glLoadIdentity();
	glTranslatef($Offset_x,$Offset_y,$Offset_z);
	SmoothShading(1);
	glRotatef($Rotation,1,1,1);
	glDisable(GL_TEXTURE_2D);


	//Okay: draw 10 - 15 arms here on different rotations.
	DrawSingleArm();
	glRotatef($defRandoms[0],1,1,0);
	DrawSingleArm();
	glRotatef($defRandoms[1],1,0,1);
	DrawSingleArm();
	glRotatef($defRandoms[2],0,1,0);
	DrawSingleArm();
	glRotatef($defRandoms[3],1,0,0);
	DrawSingleArm();
	glRotatef($defRandoms[4],0,1,1);
	DrawSingleArm();
	glRotatef($defRandoms[5],1,1,0);
	DrawSingleArm();
	glRotatef($defRandoms[6],0,1,1);
	DrawSingleArm();
	glRotatef($defRandoms[7],1,0,0);
	DrawSingleArm();
	glRotatef($defRandoms[8],1,1,0);
	DrawSingleArm();
	glRotatef($defRandoms[9],0,1,0);
	DrawSingleArm();
	glRotatef($defRandoms[10],1,0,1);
	DrawSingleArm();
	glRotatef($defRandoms[11],1,1,0);
	DrawSingleArm();
	glRotatef($defRandoms[12],1,0,1);
	DrawSingleArm();
	glRotatef($defRandoms[13],0,1,0);
	DrawSingleArm();
	glRotatef($defRandoms[14],1,1,1);
	DrawSingleArm();
	glRotatef($defRandoms[15],1,0,1);
	DrawSingleArm();
	glRotatef($defRandoms[16],0,0,1);
	DrawSingleArm();
	glRotatef($defRandoms[17],1,0,0);
	DrawSingleArm();
	glRotatef($defRandoms[18],0,1,0);
	DrawSingleArm();
	glRotatef($defRandoms[19],0,0,1);
	DrawSingleArm();



	glEnable(GL_TEXTURE_2D);
	SmoothShading(0);


}
