/*
   LGS CORE:

   (c) 2008 Menne Kamminga AKA AnalyticaL

   core function to  draw a player.

   Takes care of things like smashing players to the screen and stuff!
   Do NOT touch without consulting AnalyticaL first!! 

 */

float $t2dp;
float playerglobal $SMASH_TO_SCREEN;
float $ExtraX;
float $ExtraY;
float $ExtraZ;
float $TempZ;
float $Sound;
float $SafetyTimer;



//Main function.. decides what to do
function RenderDefaultPlayer (resource $anim_fly,resource $anim_smashscreen) {
	doUpdateModel();


	if($Player_AuraSize>=0.7) {
		AddPlayerAura();
	}

	//Include a safety net to ensure that players always come out of SMASH_TO_SCREEN
	if($SafetyTimer>1) {
		$SMASH_TO_SCREEN=0.0;
		modelanim($anim_fly);
		$Player_AnimationPRC=0.0;
	}

	if($SMASH_TO_SCREEN>=0.02) {
		$SafetyTimer+=0.002;
		SmashScreen($anim_fly,$anim_smashscreen);
	}else {
		$SafetyTimer=0;
	}
	drawmodel();
	modelcolor(1.0,1.0,1.0,0.5);
	modelcolormode(0);
	modeladdcolor(0.0,0.0,0.0,0.0);

	if($SMASH_TO_SCREEN>=0.02){
		$SafetyTimer+=0.002;
		SmashScreen2();
	}

}


//Adds a small glow to a player
function AddPlayerAura () {
	float $factor;
	$factor = $Player_AuraSize-0.7;
	$factor *= 20.0;

	$Aura_Color_R*=$factor;
	$Aura_Color_G*=$factor;
	$Aura_Color_B*=$factor;
	
	
	
	/*AddLight is a new function, it makes use of the awesome new lighting capability's 
	  of LBZ since introduction of deferred rendering*/
	/*to use: addlight(X,Y,Z,Size,R,G,B,0); */
	/*A negative size will create a "reverse" light, meaning it will light only the poly's 
	  facing away from the light. */
	/*In this case i add three lights to the scene in Aura color, INSIDE the player, 
	  lighting the poly's facing away from the player.*/
	/*This effectifly lights up the entire player in his/her aura color. */

	float $tmpy;
	$tmpy=$Player_bhandy;
	float $tmpz;
	$tmpz = $Player_bhandz -0.05;
	addlight($Player_bhandx,$tmpy,$tmpz,-0.2,$Aura_Color_R,$Aura_Color_G,$Aura_Color_B,0);
	$tmpy+=0.1;
	addlight($Player_bhandx,$tmpy,$tmpz,-0.2,$Aura_Color_R,$Aura_Color_G,$Aura_Color_B,0);
	$tmpy-=0.2;
	addlight($Player_bhandx,$tmpy,$tmpz,-0.2,$Aura_Color_R,$Aura_Color_G,$Aura_Color_B,0);
	//Also a new function: Adds to the color of the model, in this case rgb == 0 and a (shinyness) is increased.
	modeladdcolor(0.0,0.0,0.0,$factor);
}


//Updates animation on model
function doUpdateModel () {
	int $TI;
	$TI=$World_Timestop-$Player_FreeInTimeStop;
	if($TI==0) {
		if($Player_iskaoken==1) {
			updatemodelTS($TimestampNoSlow);
		}else{
			updatemodel();
		}
	}
}



//Saves current position to extraX etc
function SavePos () {
	$SMASH_TO_SCREEN=0.5;
	$ExtraX=$Offset_x;
	$ExtraY=$Offset_y;
	$ExtraZ=$Offset_z;
	$Sound=1;
	$Player_AnimationPRC=0.0;
}

//Caculate the fligh back into the game.
function CalcReturn () {
	$ExtraZ=3.0;
	$TempZ=($Player_AnimationPRC-0.5)*6.0;
	$ExtraZ-=$TempZ;
}

//Draw smash to screen effect
function SmashScreen (resource $anim_fly,resource $anim_smashscreen) {
	//Smash player to screen.
	if($SMASH_TO_SCREEN>=0.7) {
		//Make sure we keep correct position.
		SavePos();
	}
	//Set the animation:
	modelifnotanim($anim_smashscreen);
	modelanim($anim_smashscreen);
	$ExtraZ=$Player_AnimationPRC;
	$ExtraZ*=6.0;
	if($Player_AnimationPRC>=0.5) {
		CalcReturn();
	}
	//Limit Z:
	if($ExtraZ>1.3) {
		$ExtraZ=1.3;
	}
	//Fly to camera:
	glLoadIdentity();
	glTranslatef($ExtraX,$ExtraY,$ExtraZ);
	//Make sure it ends!!!
	if($Player_AnimationPRC>=0.97) {
		$SMASH_TO_SCREEN=0.0;
		modelanim($anim_fly);
		$Player_AnimationPRC=0.0;
	}
}





//Draws the nice splat onto the screen!

function SmashScreen2 () {
	//Nothing to do if we dont have reach splat point!
	if($Player_AnimationPRC>0.24) {

		if($Sound==1) {
			PlayEffect(1);
			$Sound=0;
		}
		//We get here! splat!:)
		$Texture=$TEXshatter1;
		glColor4f(1.0,1.0,1.0,1.0);
		glEnable(GL_TEXTURE_2D);
		$Size=0.07;
		$Offset_x=$ExtraX;
		$Offset_y=$ExtraY;
		$Offset_z=-1.3;
		glDisable(GL_DEPTH_TEST);
		glEnable(GL_BLEND);
		sprite();	
		glDisable(GL_BLEND);
		glEnable(GL_DEPTH_TEST);
		glDisable(GL_TEXTURE_2D);
	}
}




