/**
This is the default player animtion include:
Use this in playerrenderscripts AFTER loading the models.
It will load up the standard animations, and includes a function to set the default animations.

Example:
#model blah.xml as $mblah
#include "data/corescripts/default_playeranimation.lgs"

function main() {
	setmodel($mblah);
	setDefaultAnimations();
}
**/


#modelanim "monitor_crash" as $amonitor_crash
#modelanim "fallin" as $afallin
#modelanim "fallhi" as $afallhi
#modelanim "getup1" as $agetup1
#modelanim "flyidd" as $aflyidd
#modelanim "flybac" as $aflybac
#modelanim "flyfor" as $aflyfor
#modelanim "BB_fir" as $aBB_fir
#modelanim "flyfas" as $aflyfas
#modelanim "charge" as $acharge
#modelanim "charg2" as $acharg2
#modelanim "hit0" as $ahit0
#modelanim "hit1" as $ahit1
#modelanim "kick0" as $akick0
#modelanim "kick1" as $akick1


int playerglobal $playerGetUpFlag;
int playerglobal $playerEndOfAnimFlag;
int playerglobal $playerEndOfGetupFlag;


function setDefaultAnimations() {
	resource $currentAnim; //Used to store current animation
	resource $newAnim; //Used to select a new animation
	resource $moveanimA; //Used to retieve the animation set by the move system
	resource $moveanimB; //Used to retieve the animation set by the move system
	resource $StruggleAnimation; //Used to select a random fighting animation for struggles.
	int $Decoupled; //Used to select model ragdoll physics
	int $xaxis; //total of left + right buttons
	int $yaxis; //total of up + down buttons
	int $aaxis; //total of all directional buttons
	float $distanceToEnemy; //Stores distance to enemy
	float $distanceToEnemyY; //Stores distance to enemy + wantx/y
	float $plasthittime; //Used to retrieve how long ago the player was hit.
	int $FlyingBackwards; //used to select different flying animations when close to other player.
	int $t; //temp

	$Decoupled=0;

	//Get current animation into $currentAnim
	modelgetanim($currentAnim);
	$newAnim = $currentAnim;

	$xaxis = $Player_left + $Player_right;
	$yaxis = $Player_up + $Player_down;
	$aaxis = $xaxis + $yaxis;




	if($v_DebugRagdolls==1) {
		//The v_DebugRagdolls option is enabled in console: always detach the bones
		$Decoupled=1;
	}else {
		//Normally: detach bones when falling, or when we are just hit.
		playerGetTimeSinceLastHit($plasthittime);
		if(($Player_fall == 1 || $plasthittime>0.0 )  && $currentAnim != $amonitor_crash) {
			//Temp detach:timesincelasthit+1.0>pctimer()
			$Decoupled=1;
		}else{
			$Decoupled=0;
		}
	}

	//When the monitor_crash animation is playing: exit this function.
	if($currentAnim == $amonitor_crash) {
		modelattachbones();
		return();
	}

	//Detach bones from animation, and go into ragdoll mode.
	if($Decoupled==1) {
		modeldetachbones(0,0,0,$Player_wantx,$Player_wanty,0);
		$newAnim = $afallin;
	}

	//When close to the enemy: decide if we are flying towards, or away from:
	Length3d($distanceToEnemy,$Enemy_x,$Enemy_y,0.0);
	$FlyingBackwards = 0;
	if($distanceToEnemy < 0.66) {
		if($aaxis>0) {
			push($Offset_x);
			push($Offset_y);

			$Offset_x += $Player_wantx;
			$Offset_y += $Player_wanty;
			Length3d($distanceToEnemyY,$Enemy_x,$Enemy_y,0.0);
			if($distanceToEnemy < $distanceToEnemyY) {
				$FlyingBackwards=1;
			}else {
				$FlyingBackwards=2;
			}
			pop($Offset_y);
			pop($Offset_x);
		}
	}

	//Select an animation for melee struggle:
	$Player_strugglerandom *= 4.99;
	floor($Player_strugglerandom,$t);
	if($t==0) {
		$StruggleAnimation = $acharge;
	}else if($t==1) {
		$StruggleAnimation = $akick1;
	}else if($t==2) {
		$StruggleAnimation = $akick0;
	}else if($t==3) {
		$StruggleAnimation = $ahit1;
	}else {
		$StruggleAnimation = $ahit0;
	}
	

	
	if($Player_fall) {
		//Player is falling: play falling animation
		$newAnim = $afallin; 
	} else if($Player_anim_is_controlled_by_move) {
		//use the movesystem to decide animation:
		playergetmoveanims($moveanima,$moveanimb);
		if( $currentAnim != $moveanimb) { $newAnim = $moveanima; }
	}else{
		//Set a flag when a player is playing the hit the ground/get up animations
		if($currentAnim == $afallhi || $currentAnim == $agetup1) {
			$playerGetUpFlag=1;
		}else {
			$playerGetUpFlag=0;
		}

		if($Player_justfell==1) {
			if($currentAnim != $agetup1) {
				$newAnim = $afallhi;
			}
		}else if($Player_meleestruggle==1) {
			$newAnim = $StruggleAnimation;
		}else if($Player_donotc>0.0) {
			$newAnim = $aflyidd;
		}else{
			if($aaxis==0 && $Player_attack1==0&&$Player_attack2==0&&$Player_kikey==0) {
				//the flyidd animation
				$newAnim = $aflyidd;
			}else {
				if($FlyingBackwards &&$Player_attack1==0 && $Player_attack2==0&&$Player_kikey==0) {
					if($FlyingBackwards==1) {
						if($currentAnim != $aBB_fir) { $newAnim = $aflybac; }
					}else {
						if($currentAnim != $aBB_fir) { $newAnim = $aflyfor; }
					}
				}else {
					if($distanceToEnemy>=0.66 && $aaxis>0 &&$Player_attack1==0&&$Player_attack2==0&&$Player_kikey==0&&$Player_TakeSnapShot==0) {
						$newAnim = $aflyfas;
					}else if($distanceToEnemy<0.66 && $aaxis>0 &&$Player_attack1==0&&$Player_attack2==0&&$Player_kikey==0) {
						if($currentAnim != $aBB_fir) { $newAnim = $aflyidd; }
					}
				}
			}
			//the charging animations
			if( ($Player_down==0 && $xaxis==0 && $Player_up==1 ) && $Player_attack1==0 && $Player_attack2==0 && $Player_kikey==1) {
				//the charge animation
				$newAnim = $acharge;
			} else if($Player_IsBlocking==1&&$Player_kikey==1) {
				$newAnim = $acharg2;
			}
		}
	}

	//Retrieve endOfAnimation flag from model:
	modelgetendofanim($playerEndOfAnimFlag);
	if($playerEndOfAnimFlag && $currentAnim == $agetup1) {
		$playerEndOfGetupFlag = 1;
	}
	
	//Reattach bones:
	if($Decoupled==0) {
		modelattachbones();
	}
	

	//Set the new animation (if we are not already playing it...)
	if($currentAnim != $newAnim) {
		//prn($newAnim);
		modelanim($newAnim);
	} 
}